#<profile4xi profile = "31"/>
#<program4xi program = "generate2dragon4xi.py">
#<abstract4xi abstract = "generates new updated objects from defined ones such as HTML file objects"/>
#<refer4xi reference = "Studio4Xi"/>
#<use4xi usage = "see kb4site and ADJUST for settings before running!"/>
#<note4xi note = "fetch2dragon4xi.py can be used to fecth input although typically you copy the whole folder for input"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'generate2dragon4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from print4xi import print4xi
from print4xi import Print4Xi 
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                             
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global anchor2search

global anchor2web
global len2anchor
global anchor2web4secure
global len2anchor4secure

global anchor2image4you
global len2anchor4web
global end2mini4object
global end2short4object
global end2embedded4object
global end2short4html
global end2long4html
global end2embedded4html
global source2image
global len2source4image

global count2skipped
global count2failure4absolute
global count2failure4relative
global count2found4line
global count2modify4anchor
global count2total4anchor
global count2total4image
global count2total
global count2embedded4anchor
global count2web4anchor
global count2portal4anchor
global count2jpg4image
global count2png4image
global count2your4image

global kb4site
global kb2url4check

global level2input
global line2skip
global branch2input
global leaf2branch
global branch2leaf

global path2input4portal
global path2temp4source  
global path2read4xi                          # path for input source objects
global path2write4xi                         # path for output source objects

global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count

global special2jpg4you
global len2special4jpg
global special2png4you
global len2special4png

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
anchor2search = '<a href='
len2anchor = len(anchor2search)

anchor2web = '<a href="http://'
len2anchor4web = len(anchor2web)

anchor2web4secure = '<a href="https://'      
len2anchor4secure = len(anchor2web4secure)

anchor2image4you = 'https://www.yourdragonxi.org/web/images/'
end2mini4object      = '"'                                                        
end2short4object      = '/"'
end2embedded4object   = '/#"'
end2short4html        = '.htm">'
end2long4html         = '.htm">'
end2embedded4html     = '.html#"'
source2image = '<img src='
len2source4image = len(source2image)
line2skip = '<img src="https://www.yourdragonxi.org/web/images/png/1_q.png"'

special2jpg4you = 'https://www.yourdragonxi.org/web/images/jpg/'
len2special4jpg = len(special2jpg4you)
special2png4you = 'https://www.yourdragonxi.org/web/images/png/'
len2special4png = len(special2png4you)


count2skipped = 0
count2failure4absolute = 0
count2failure4relative = 0
count2found4line = 0
count2modify4anchor = 0
count2total4anchor = 0
count2total4image = 0
count2total = 0
count2embedded4anchor = 0
count2web4anchor = 0
count2portal4anchor = 0
count2jpg4image = 0
count2png4image = 0
count2your4image = 0

kb2url4check = {}

# -------------------------------------------------------------------------------------------------
# DEFINE KNOWLEDGEBASE FOR PORTAL
# -------------------------------------------------------------------------------------------------                                                                                           
kb4site = {}
kb4site[0] = {}
kb4site[0] [0]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//'

kb4site[1] = {} 
kb4site[1] [1]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//ace//'
kb4site[1] [2]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//brainstorm//'
kb4site[1] [3]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//brand//'
kb4site[1] [4]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//design//'
kb4site[1] [5]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//master//'
kb4site[1] [6]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//net//'
kb4site[1] [7]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//produce//'
kb4site[1] [8]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//reason//'
kb4site[1] [9]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//sense//'

kb4site[1] [10] = {}
kb4site[1] [10] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//'

kb4site[1] [10] [1] = {}
kb4site[1] [10] [1] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//alpha//'
kb4site[1] [10] [1] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//alpha//bus//'
kb4site[1] [10] [1] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//alpha//mil//'
kb4site[1] [10] [1] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//alpha//pat//'

kb4site[1] [10] [2] = {}
kb4site[1] [10] [2] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//'
kb4site[1] [10] [2] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//bus//'
kb4site[1] [10] [2] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//mil//'
kb4site[1] [10] [2] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//pat//'

kb4site[1] [10] [3] = {}
kb4site[1] [10] [3] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//delta//'
kb4site[1] [10] [3] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//delta//bus//'
kb4site[1] [10] [3] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//delta//mil//'
kb4site[1] [10] [3] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//delta//pat//'

kb4site[1] [10] [4] = {}
kb4site[1] [10] [4] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//epsilon//'
kb4site[1] [10] [4] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//epsilon//bus//'
kb4site[1] [10] [4] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//epsilon//mil//'
kb4site[1] [10] [4] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//epsilon//pat//'

kb4site[1] [10] [5] = {}
kb4site[1] [10] [5] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//gamma//'
kb4site[1] [10] [5] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//gamma//bus//'
kb4site[1] [10] [5] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//gamma//mil//'
kb4site[1] [10] [5] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//gamma//pat//'

kb4site[1] [10] [6] = {}
kb4site[1] [10] [6] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//'
kb4site[1] [10] [6] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//bus//'
kb4site[1] [10] [6] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//mil//'
kb4site[1] [10] [6] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//pat//'

kb4site[1] [10] [7] = {}
kb4site[1] [10] [7] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//zeta//'
kb4site[1] [10] [7] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//zeta//bus//'
kb4site[1] [10] [7] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//zeta//mil//'
kb4site[1] [10] [7] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//zeta//pat//'

kb4site[1] [10] [8] = {}
kb4site[1] [10] [8] [0]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//'
kb4site[1] [10] [8] [1]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//base//'
kb4site[1] [10] [8] [2]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//bio//'
kb4site[1] [10] [8] [3]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//calc//'
kb4site[1] [10] [8] [4]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//ecar//'
kb4site[1] [10] [8] [5]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//helicopter//'
kb4site[1] [10] [8] [6]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//hrw//'
kb4site[1] [10] [8] [7]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//matter//'
kb4site[1] [10] [8] [8]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//pod4xi//'
kb4site[1] [10] [8] [9]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//sensor4xi//'
kb4site[1] [10] [8] [10] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//srw//'
kb4site[1] [10] [8] [11] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//xcopter//'
kb4site[1] [10] [8] [12] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//xi//'

kb4site[1] [11] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//test//'

kb4site[1] [12]  = {}
kb4site[1] [12] [1] = {}
kb4site[1] [12] [1] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//'
kb4site[1] [12] [1] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//bp//'
kb4site[1] [12] [1] [2] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//nda//'
kb4site[1] [12] [1] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//ss//'

kb4site[1] [13] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//web//'
ack2define = False

# -------------------------------------------------------------------------------------------------
# INPUT
# -------------------------------------------------------------------------------------------------
level2input   = 1
branch2input  = 10
leaf2branch = 6
branch2leaf = 1 

# -------------------------------------------------------------------------------------------------
# PATHS
# -------------------------------------------------------------------------------------------------
path2input4portal = kb4site[0] [0]
path2read4xi  = VersionKB4Xi['input2generate4scope']  # walked folder
path2write4xi = VersionKB4Xi['output2generate4scope'] # put    folder with all subfolders a ... z

# -------------------------------------------------------------------------------------------------
# PICKLING
# -------------------------------------------------------------------------------------------------
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>
# -------------------------------------------------------------------------------------------------
# 
# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C
                                             # '.html', 'xml' ...

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4generate" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4generate():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) OF SET2TRACE4GENERATE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF SET2TRACE4GENERATE - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 02A/33) OF SET2TRACE4GENERATE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 033/33) OF SET2TRACE4GENERATE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4generate" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4generate():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4GENERATE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4GENERATE - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4GENERATE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4GENERATE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4GENERATE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("(Step 0: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4GENERATE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4GENERATE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4GENERATE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4GENERATE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4GENERATE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4generate" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4generate():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 01A/33) OF TAILOR2TRACE4GENERATE - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'generate2dragon4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 02A/33) OF TAILOR2TRACE4GENERATE - MARKED TO BE TESTED: ", key2tailor)
        # generate2dragon4xi

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 033/33) OF TAILOR2TRACE4GENERATE - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print2trace4dragonize" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print2trace4dragonize(t2xi):

    class2print  = "generate2dragon4xi"
    method2print = "generate2dragon4xi" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-generate2object4dragon.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing generate2dragon4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">generate2dragon4xi sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-generate2object4dragon.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for generate2dragon4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-generate2object4dragon.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for generate2dragon4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of generate2dragon4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4dragonize                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "generate2dragon4xi" usage = "
#   generates modified and improved objects such as HTML files with better anchor handling
#"> 
# -------------------------------------------------------------------------------------------------
def generate2dragon4xi(input2explore):

    global count2skipped
    global count2failure4absolute
    global count2failure4relative
    global count2found4line
    global count2modify4anchor
    global count2total4anchor
    global count2total4image
    global count2total
    global count2embedded4anchor
    global count2web4anchor
    global count2portal4anchor
    global count2jpg4image
    global count2png4image
    global count2your4image

    global kb4site
    global kb2url4check

    global level2input
    global line2skip
    global branch2input
    global leaf2branch
    global branch2leaf    
        
    global path2input4portal                     # path of input for portal
    global path2read4xi                          # path for input source objects
    global path2write4xi                         # path for output source objects
    global profile2fetch                         # extension for files

       
    global t2xi
    global trace_object_count    
    
    class2print  = "generate2dragon4xi"
    method2print = "generate2dragon4xi" 
    
    global anchor2search
    
    global anchor2web
    global anchor2image4you
    
    global anchor2web4secure 
    global len2anchor4secure
    
    global source2image
    global len2source4image
    
    global len2anchor
    global len2anchor4web
    
    global end2mini4object
    global end2short4object
    global end2embedded4object
    global end2short4html
    global end2long4html
    global end2embedded4html

    global special2jpg4you
    global len2special4jpg
    global special2png4you
    global len2special4png    
        
    # message2print = "{(Step 0A/33) using" + "; t2xi-using-by-generate2dragon4xi: " + str(t2xi)  + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x00000000032DFFD0>
    
    message2print = "{(Step 0B/33) got" + "; input2explore-got-by-generate2dragon4xi: " + str(input2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT OBJECT NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2object=os.path.splitext(input2explore)
    
    if name2object[1] == profile2fetch:          
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF GENERATE2DRAGON4XI - INPUT FILE IS RIGHT TYPE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; input2explore-analyzing-by-generate2dragon4xi: " + str(input2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html
        
        
        path2input = name2object[0] + profile2fetch 
        message2print = "{(Step 1B/33) set" + "; path2input-set-by-generate2dragon4xi to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html
         
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF GENERATE2DRAGON4XI - ANALYZE INPUT 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) analyzing" + "; path2input-analyzing-by-generate2dragon4xi: " + str(path2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF GENERATE2DRAGON4XI
        # -----------------------------------------------------------------------------------------        
        file2input = open(path2input,'r')
        message2print = "{(Step 4A/33) opened" + "; file2input-opened-by-generate2dragon4xi: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html' mode='r' encoding='cp1252'>
 
            
        # ---------------------------------------------------------------------------------
        # (Step 4C/33) OF GENERATE2DRAGON4XI - GET OBJECT TO BE GENERATED 
        # ---------------------------------------------------------------------------------                        
        # path2input:   V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html                       
        # path2read4xi: V://JOB//studio4xi//cc//generate//in//
        object2write = None
        ack2output = False
        ack2input = False
        try:
            object2write = path2input[len(path2read4xi):]
            ack2input = True
            
            message2print = "{(Step 4B1/33) set" + "; object2write-set-by-generate2dragon4xi to: " + str(object2write)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # spec_aut_007_3.html
               
            path2write4object = path2write4xi + object2write
            message2print = "{(Step 4B2/33) set" + "; path2write4object-set-by-generate2dragon4xi to: " + str(path2write4object)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            # V://JOB//studio4xi//cc//generate//out//spec_aut_007_3.html
        
            file2output = open(path2write4object,'w')
            message2print = "{(Step 4B3/33) opened" + "; file2output-opened-by-fetch2dragon4xi: " + str(file2output) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//out//spec_aut_007_3.html' mode='w' encoding='cp1252'> 
            
            ack2output = True
        except:
            message2print = "{(Step 4Z1/33) failed" + "; object2write-failed-by-fetch2dragon4xi: " + str(object2write) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            #
        
        if ack2output is True:                                                  
            while 1:
                # -------------------------------------------------------------------------------------
                # (Step 5/33) OF GENERATE2DRAGON4XI - LINES OF SOURCE FILE
                # -------------------------------------------------------------------------------------             
                line2process = file2input.readline()
                if not line2process:
                    # ---------------------------------------------------------------------------------
                    # (Step 5X/33) OF GENERATE2SCOPE4XI - ALL LINES READ, FINISH
                    # ---------------------------------------------------------------------------------             
                    message2print = "{(Step 5X/33) performed" + "; file2input-performed-by-generate2dragon4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html' mode='r' encoding='cp1252'>
                    break                                               
                else:
                    # ------------------------------------------------------------------------------------
                    # (Step 6/33) OF GENERATE2DRAGON4XI - PROCESS ONE LINE OF SOURCE FILE
                    # ------------------------------------------------------------------------------------   
                    message2print = "{(Step 6A/33) got" + "; line2process-got-by-generate2dragon4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <p> 
                    # <br>catch <b>&raquo;</b><a href="spec_std_007_3/">Next</a> <b>&raquo;</b><a href="spec_ui_007_3/">Previous</a> <b>&raquo;</b><a href="index_bus_lambda/">Home</a>!
                    # 0123456789012345678901234       01234567890123456789012345678901234567890123456789
                    # ~[<a href="../../wiki/h/hydrogen/" target="_blank">hydrogen</a>] ~[<a href="../../wiki/f/fuel_cell/" target="_blank">fuel_cell</a>] ~[<a href="#002">next</a>]!
                    #
                    # <br /><img src="../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />
                    # <a href="#001"><img src="https://www.yourdragonxi.org/web/images/png/1_q.png" alt="yourDragonXi" height="26" width="26" align="top" hspace="0" vspace="0" /></a>~ <b>M</b>acros<br />
                    # <br /><b>&xi;</b> <a href="http://www.nato.int/">NATO</a>
                    # line2process-got-by-generate2dragon4xi: <br /><b>&xi;</b>  <a href="../xi/distance_range_base4xi_xi">Distance Range Base4Xi - Xi</a>
                    # <br /><b>&raquo;</b><a href="https://my.webfaction.com/" target="_blank">WebFaction</a> 
                    # <td><a href="../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                    # <td><a href="bp_001/"><img src="https://www.yourdragonxi.org/web/images/jpg/thiwho.jpg" height="120" width="204" align="left" /></a></td> 
                    
                    count2total = count2total + 1                                                                   # update statitics for lines read from this source file
                    
                    
                    ack2anchor4line = False                                                                         # assume no anchors exist
                    ack2image4line = False                                                                          # assume no images exist
                    ack2jpg4image = False                                                                           # assume no jpg images                                                               
                    ack2png4image = False                                                                           # assume no png images
                    ack2yoimage = False                                                                             # assume no your image
                    ack2reference4check = False                                                                     # assume no references

                    ack2anchor4type = False 
                    ack2hyperlink = False
                    ack2image4type = False
                    ack2html4type = False
                    ack2skipped4type = False

                    index2skip = str.find(line2process,line2skip)
                    if index2skip == -1:
                        ack2job4line = True                                                                         # job to be done for this line
         
                        target2search = line2process                                                                # initialize work area for line  
                    
                        message2print = "{(Step 6B1/33) set" + "; target2search-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # ~[<a href="../../wiki/h/hydrogen/" target="_blank">hydrogen</a>] ~[<a href="../../wiki/f/fuel_cell/" target="_blank">fuel_cell</a>] ~[<a href="#002">next</a>]!
                        # <br /><img src="../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />
                        # <p> 
                        # See also <b>&raquo;</b><a href="../pat/spec_pow_009_2/">Patrol</a> and <b>&raquo;</b><a href="../mil/spec_pow_009_1/">Military</a> power!
                        # <br /><b>&xi;</b>  <a href="../xi/distance_range_base4xi_xi">Distance Range Base4Xi - Xi</a>
                        # <br /><b>&raquo;</b><a href="https://my.webfaction.com/" target="_blank">WebFaction</a>
                        # <br /><b>&xi;</b> <b>&raquo;</b><a href="../../../sense/uas/index-uas-xi/" target="_blank">Unmanned aerial systems</a>
                        # <td><a href="../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                        # <td><a href="bp_001/"><img src="https://www.yourdragonxi.org/web/images/jpg/thiwho.jpg" height="120" width="204" align="left" /></a></td>
                        
                    else:
                        count2skipped = count2skipped + 1
                        ack2job4line = False                                                                        # skip this line
                        message2print = "{(Step 6B1/33) skipped" + "; line-skipped-by-generate2dragon4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                      
                        # <a href="#001"><img src="https://www.yourdragonxi.org/web/images/png/1_q.png" alt="yourDragonXi" height="26" width="26" align="top" hspace="0" vspace="0" /></a>~ <b>M</b>acros<br />
                        
                    while ack2job4line is True:
                        # ------------------------------------------------------------------------------------------
                        # JOB TO BE DONE ON THIS LINE
                        # ------------------------------------------------------------------------------------------    
                        # bp_019.html read BUT <td><a href="bp_019/"><img src="https://www.yourdragonxi.org/web/images/jpg/whatwedo9.jpg" height="120" width="204" align="left" /></a><br /></td>
                        try: 
                            ack2reference4check = False            
                            index2anchor = str.find(target2search,anchor2search)                                    # search anchor in the line
                            message2print = "{(Step 6C1/33) set" + "; index2anchor-set-by-generate2dragon4xi to: " + str(index2anchor)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 3; -1 
                            # anchor2image4you = 'https://www.yourdragonxi.org/web/images/' for example <a href="#001"><img src="https://www.yourdragonxi.org/web/images/png/1_q.png" alt="yourDragonXi" height="26" width="26" align="top" hspace="0" vspace="0" /></a>~ <b>M</b>acros<br />
                            # end2short4object      = '/"'
                            # end2embedded4object   = '/#"'
                            # end2short4html        = '.htm">'
                            # end2long4html         = '.htm">'
                            # end2embedded4html     = '.html#"'
                            # <img src="../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />
                            # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                            # set; index2anchor-set-by-generate2dragon4xi to: -1; time: 05:11:31 06/02/12 Pacific Daylight Time}
                            
                            if index2anchor == -1:
                                # ----------------------------------------------------------------------------------
                                # NO ANCHOR BUT IMAGE MIGHT HAVE BEEN REFERRED
                                # ----------------------------------------------------------------------------------                                                                  
                                ack2anchor4type = False
                                index2image = str.find(target2search,source2image)                                  # '<img src='  
                                if index2image  == -1:
                                    # ------------------------------------------------------------------------------
                                    # NO IMAGE AND NO ANCHOR REFERRED
                                    # ------------------------------------------------------------------------------
                                    ack2job4line = False
                                    message2print = "{(Step 6C21/33) set" + "; ack2job4line-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)          
                                    # ../mil/spec_aut_007_1/">Military</a> autonomous

                                else:
                                    # -----------------------------------------------------------------------------------
                                    # IMAGE REFERRED - MUST BE EITHER IN JPG OR PNG FOLDER (AS OBJECT IT HAS NO EXTENSION)
                                    # -----------------------------------------------------------------------------------
                                    ack2reference4check = True 
                                    message2print = "{(Step 6C3/33) decided" + "; ack2reference4check-decided-by-generate2dragon4xi: " + str(ack2reference4check) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # ack2reference4check-decided-by-generate2dragon4xi: True; time: 06:24:27 06/02/12 Pacific Daylight Time}
                                    
                                    index2jpg = str.find(target2search,'jpg')                                       # jpg image ?
                                    if index2jpg == -1:
                                        # --------------------------------------------------------------------------
                                        # NOT JPG
                                        # --------------------------------------------------------------------------
                                        index2png = str.find(target2search,'png')                                   # png image ?
                                        if index2png == -1:
                                            # ----------------------------------------------------------------------
                                            # NOT PNG - UNKNOWN IMAGE TYPE!
                                            # ----------------------------------------------------------------------
                                            message2print = "{(Step 6Z2/33) failed" + "; target2search-failed-by-generate2dragon4xi: " + str(target2search) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #              
                                        else:
                                            # --------------------------------------------------------------------------
                                            # HANDLE SPECIAL .PNG CASES 
                                            # --------------------------------------------------------------------------
                                            # <td><a href="bp_019/"><img src="https://www.yourdragonxi.org/web/images/png/whatwedo9.png" height="120" width="204" align="left" /></a><br /></td>
                                            # special2png4you, len2special4png, special2png4you, len2special4png
                                            index2special4you = str.find(target2search,special2png4you)
                                            # JATKA
                                            if index2special4you == -1:
                                                # ----------------------------------------------------------------------
                                                # NORMAL PNG IMAGE REFRENCE
                                                # ----------------------------------------------------------------------                                                  
                                                ack2image4type = True
                                                ack2png4image = True
                                                count2png4image = count2png4image + 1
                                                count2total4image = count2total4image + 1
                                                message2print = "{(Step 6E/33) added" + "; count2png4image-added-by-generate2dragon4xi: " + str(count2png4image) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # count2png4image-added-by-generate2dragon4xi: 1; time: 02:55:49 05/28/12 Pacific Daylight Time}
                                                
                                                ack2reference4check = True
                                            else:
                                                # ----------------------------------------------------------------------
                                                # SKIP PNG OF YOURDRAGONXI.ORG
                                                # ----------------------------------------------------------------------
                                                target2search = target2search[index2special4you + len2special4png:]
                                                # /whatwedo9.png" height="120" width="204" align="left" /></a><br /></td>
                                                end2png4you = str.find(target2search,'.png')
                                                if end2png4you == -1:
                                                    pass
                                                else:
                                                    target2search = target2search[end2png4you+5:] 
                                                    # height="120" width="204" align="left" /></a><br /></td>                                              
                                                    count2your4image = count2your4image + 1 
                                    else:
                                        # --------------------------------------------------------------------------
                                        # .JPG 
                                        # --------------------------------------------------------------------------
                                        # <td><a href="bp_019/"><img src="https://www.yourdragonxi.org/web/images/jpg/whatwedo9.jpg" height="120" width="204" align="left" /></a><br /></td>
                                        # special2jpg4you, len2special4jpg, special2png4you, len2special4png
                                        index2special4you = str.find(target2search,special2jpg4you)
                                        if index2special4you == -1:
                                            # ----------------------------------------------------------------------
                                            # NORMAL JPG IMAGE REFRENCE
                                            # ----------------------------------------------------------------------     
                                            ack2image4type = True
                                            ack2jpg4image = True
                                            count2jpg4image = count2jpg4image + 1
                                            count2total4image = count2total4image + 1
                                            message2print = "{(Step 6E/33) added" + "; count2jpg4image-added-by-generate2dragon4xi: " + str(count2jpg4image) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # count2jpg4image-added-by-generate2dragon4xi: 1; time: 02:55:49 05/28/12 Pacific Daylight Time}
                                            
                                            ack2reference4check = True
                                        else:
                                            # ----------------------------------------------------------------------
                                            # SKIP JPG OF YOURDRAGONXI.ORG
                                            # ----------------------------------------------------------------------                                       
                                            target2search = target2search[index2special4you + len2special4jpg:]
                                            # /whatwedo9.jpg" height="120" width="204" align="left" /></a><br /></td>
                                            end2jpg4you = str.find(target2search,'.jpg')
                                            if end2jpg4you == -1:
                                                pass
                                            else:
                                                target2search = target2search[end2jpg4you+5:] 
                                                # height="120" width="204" align="left" /></a><br /></td> 
                                                count2your4image = count2your4image + 1          
                                            
                                    ack2yoimage = False
                                    if ((ack2png4image is True) or (ack2jpg4image is True)):                        # only if we have reference to image in this line
                                        index2yoimage = str.find(target2search,anchor2image4you)                    # <a href="#001"><img src="https://www.yourdragonxi.org/web/images/png/1_q.png" 
                                        if index2yoimage == -1:
                                            message2print = "{(Step 6F/33) decided" + "; ack2yoimage-decided-by-generate2dragon4xi: " + str(ack2yoimage) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # ack2yoimage-decided-by-generate2dragon4xi: False; time: 02:55:49 05/28/12 Pacific Daylight Time}
                                            
                                            ack2image4type = True
                                        else: 
                                            ack2image4type = False                       
                                            count2your4image = count2your4image + 1
                                            count2total4image = count2total4image + 1
                                            message2print = "{(Step 6G/33) added" + "; count2your4image-added-by-generate2dragon4xi: " + str(count2your4image) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print) 
                                            ack2yoimage = True 
                                            ack2image4type = False  
                                    else:
                                        pass    
                                                                                               
                            else:
                                ack2reference4check = True    
                                ack2anchor4type = True    
                                
                            # --------------------------------------------------------------------------------------
                            #
                            # --------------------------------------------------------------------------------------
                             
                            if ack2reference4check is True:                                                         
                                # ----------------------------------------------------------------------------------
                                # EITHER ANCHOR OR IMAGE SOURCE REFERENCE
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 6H/33) decided" + "; ack2reference4check-decided-by-generate2dragon4xi: " + str(ack2reference4check) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                
                                try:
                                    if ack2anchor4type is True:
                                        # ------------------------------------------------------------------------------
                                        # ANCHOR REFERENCE
                                        # ------------------------------------------------------------------------------
                                        count2total4anchor = count2total4anchor + 1                                     # update statitics for anchors   
                                        message2print = "{(Step 6I/33) added" + "; count2total4anchor-added-by-generate2dragon4xi: " + str(count2total4anchor) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # count2total4anchor-added-by-generate2dragon4xi: 92; time: 04:25:25 06/02/12 Pacific Daylight Time}
                                        
                                        if ack2anchor4line is False:                                                    # already updated ?
                                            count2found4line = count2found4line + 1                                     # update statistics for anchor lines
                                            ack2anchor4line = True
                                        else:
                                            pass   
                                                 
                                        # <a href="http://www.nato.int/">NATO</a> 
                                        # try:
                                        #     import urllib.request
                                        #     file2web = urllib.request.urlopen('http://www.nato.int/')
                                        #     message2print = "{(Step 6J0/33) got" + "; file2web-got-by-generate2dragon4xi: " + str(file2web)  + "; time: " + time4xi() + "}"
                                        #     print4xi(class2print, method2print, message2print)
                                        #     # 
                                        # except:
                                        #     message2print = "{(Step 6Z0/33) failed" + "; file2web-failed-by-generate2dragon4xi: " + str(target2search) + "; time: " + time4xi() + "}"
                                        #     print4xi(class2print, method2print, message2print)
                                        #     #  
                                        
                                        # --------------------------------------------------------------------------
                                        # http:// ? 
                                        # --------------------------------------------------------------------------   
                                        index2anchor4web = str.find(target2search,anchor2web)
                                        message2print = "{(Step 6J01/33) set" + "; index2anchor4web-set-by-generate2dragon4xi to: " + str(index2anchor4web)  + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # -1 for ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>           
                                        if index2anchor4web == -1:
                                            # --------------------------------------------------------------------------    
                                            # NOT http:// - https:// ?    
                                            # --------------------------------------------------------------------------  
                                            index2anchor4secure = str.find(target2search,anchor2web4secure)
                                            message2print = "{(Step 6J02/33) set" + "; index2anchor4secure-set-by-generate2dragon4xi to: " + str(index2anchor4secure)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # -1 for ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td> 
                                            
                                            if index2anchor4secure == -1:
                                                # --------------------------------------------------------------------------    
                                                # NOT http:// and NOT https:// - ASSUME(!) INTERNAL LINK (not FTP etc) 
                                                # --------------------------------------------------------------------------                                             
                                                ack2hyperlink = False
                                                                                                  
                                                message2print = "{(Step 6J1/33) set" + "; ack2hyperlink-set-by-generate2dragon4xi to: " + str(ack2hyperlink)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # False for ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                                
                                                                                                
                                            else:
                                                # --------------------------------------------------------------------------    
                                                # YES - https://    
                                                # -------------------------------------------------------------------------- 
                                                # 
                                                target2search = target2search[index2anchor4secure + len2anchor4secure:]
                                                message2print = "{(Step 6J2/33) set" + "; target2search-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # my.webfaction.com/" target="_blank">WebFaction</a>
                                                
                                                ack2hyperlink = True
                                                count2web4anchor = count2web4anchor + 1
                                                
                                                message2print = "{(Step 6J3/33) added" + "; ack2hyperlink-secure-added-by-generate2dragon4xi to: " + str(ack2hyperlink)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                #  
                                                
                                                kb2url4check[count2web4anchor] = target2search
                                                                                        
                                            target2search = target2search[index2anchor + 1 + len2anchor:]                   
                                            message2print = "{(Step 6J4/33) set" + "; target2search-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # ../../wiki/h/hydrogen/" target="_blank">hydrogen</a>] ~[<a href="../../wiki/f/fuel_cell/" target="_blank">fuel_cell</a>] ~[<a href="#002">next</a>]!
                                            # ../pat/spec_pow_009_2/">Patrol</a> and <b>&raquo;</b><a href="../mil/spec_pow_009_1/">Military</a> power!
                                            # ../xi/distance_range_base4xi_xi">Distance Range Base4Xi - Xi</a>
                                            # bp_007/#0071/">First year</a></td>
                                            # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                            # bp_001/"><img src="https://www.yourdragonxi.org/web/images/jpg/thiwho.jpg" height="120" width="204" align="left" /></a></td>
                                        else:
                                            # --------------------------------------------------------------------------    
                                            # YES - http://    
                                            # --------------------------------------------------------------------------                                         
                                            target2search = target2search[index2anchor4web + len2anchor4web:]
                                            message2print = "{(Step 6J5/33) set" + "; target2search-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # target2search-set-by-generate2dragon4xi to: www.nato.int/">NATO</a>
                                            
                                            ack2hyperlink = True
                                            count2web4anchor = count2web4anchor + 1
                                            
                                            message2print = "{(Step 6J6/33) added" + "; ack2hyperlink-added-by-generate2dragon4xi to: " + str(ack2hyperlink)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # ack2hyperlink-set-by-generate2dragon4xi to: True; time: 11:13:51 05/28/12 Pacific Daylight Time}
                                            
                                            kb2url4check[count2web4anchor] = target2search
 
                                        # --------------------------------------------------------------------------
                                        #
                                        # --------------------------------------------------------------------------    
                                    else:
                                        message2print = "{(Step 6K/33) decided" + "; ack2anchor4type-decided-by-generate2dragon4xi: " + str(ack2anchor4type) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # ack2anchor4type-decided-by-generate2dragon4xi: False; time: 02:55:49 05/28/12 Pacific Daylight Time}
                                except:
                                    message2print = "{(Step 6Z1/33) failed" + "; anchor-targetsetting-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                
                               
                                try:    
                                    if ack2image4type is True:
                                        # ------------------------------------------------------------------------------
                                        # IMAGE REFERENCE 
                                        # ------------------------------------------------------------------------------
                                        if ack2image4line is False:
                                            # count2found4line = count2found4line + 1 Kaiserdom 
                                            ack2image4line = True
                                        else:
                                            pass    
                                        if ((ack2jpg4image is True) or (ack2png4image is True)):
                                            # <img src="../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />
                                            # index2image = str.find(target2search,source2image)                                  # '<img src='  
                                            
                                            target2search = target2search[index2image + 1 + len2source4image:]
                                            message2print = "{(Step 6L/33) set" + "; target2search-set-by-generate2dragon4xi to: " + str(target2search)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # ../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />   
                                        else:
                                            pass    
                                    else:
                                        message2print = "{(Step 6M/33) decided" + "; ack2image4type-decided-by-generate2dragon4xi: " + str(ack2image4type) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # decided; ack2image4type-decided-by-generate2dragon4xi: False; time: 05:11:31 06/02/12 Pacific Daylight Time}       
                                except:
                                    message2print = "{(Step 6Z2/33) failed" + "; image-target-setting-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False      
                                                                            
                                # ------------------------------------------------------------------------------------
                                # (Step 7/33) OF GENERATE2DRAGON4XI - CONCLUDE ANCHOR TYPE
                                # ------------------------------------------------------------------------------------   
                                ack2file = True                                                                     # default link is to another file in the same folder
                                
                                ack2embedded  = False                                                               # internal link inside the file
                                ack2relative = False                                                                # relative link into another file in different folder
                                
                                
                                ack2image4you = False                                                               # www.yourdragonxi.org public images
                                
                                try:
                                    if ack2jpg4image is True:
                                        # --------------------------------------------------------------------------
                                        # JPG IMAGE
                                        # --------------------------------------------------------------------------
                                        message2print = "{(Step 7A/33) concluded" + "; ack2jpg4image-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print) 
                                        # ../../images/jpg/xi_bus_01/"  
                                except:
                                    message2print = "{(Step 7Z1/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False
                                try:                                           
                                    if ack2png4image is True:
                                        # --------------------------------------------------------------------------
                                        # PNG IMAGE
                                        # --------------------------------------------------------------------------
                                        message2print = "{(Step 7B/33) concluded" + "; ack2png4image-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print) 
                                        #
                                except:
                                    message2print = "{(Step 7Z2/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                         
                                try:         
                                    if target2search[0] == '#':
                                        # --------------------------------------------------------------------------
                                        # EMBEDDED
                                        # --------------------------------------------------------------------------
                                        ack2embedded  = True
                                        message2print = "{(Step 7C/33) concluded" + "; ack2embedded-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print) 
                                        # #001">[001]</a>~ ...
                                except:
                                    message2print = "{(Step 7Z3/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                         
                                try:             
                                    if target2search[0] == '.':
                                        # --------------------------------------------------------------------------
                                        # RELATIVE
                                        # --------------------------------------------------------------------------
                                        ack2relative = True
                                        message2print = "{(Step 7D/33) concluded" + "; ack2relative-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # ../pat/spec_aut_007_2, ../mil/spec_aut_007_1 , ../../wiki/h/hydrogen/" 
                                        # ../../images/jpg/xi_bus_01/" 
                                        # ack2relative-concluded-by-generate2dragon4xi: ../pat/spec_pow_009_2/">Patrol</a; time: 01:07:36 05/29/12 Pacific Daylight Time}
                                        # ack2relative-concluded-by-generate2dragon4xi: ../xi/distance_range_base4xi_xi">; time: 05:53:52 05/29/12 Pacific Daylight Time}
                                        # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                except:
                                    message2print = "{(Step 7Z4/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                         
                                try:        
                                    if ack2hyperlink is True:
                                       # --------------------------------------------------------------------------
                                       # HTTP PROTOCOL 
                                       # --------------------------------------------------------------------------
                                       ack2file = False
                                       message2print = "{(Step 7E/33) concluded" + "; ack2hyperlink-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)
                                       # 
                                except:
                                    message2print = "{(Step 7Z5/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                        
                                try:       
                                    if target2search[0:3] == 'file':
                                       # --------------------------------------------------------------------------
                                       # FILE PROTOCOL
                                       # --------------------------------------------------------------------------
                                       message2print = "{(Step 7F/33) concluded" + "; ack2file-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)
                                except:
                                    message2print = "{(Step 7Z6/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                        
                                try:       
                                    if target2search[0:len(anchor2image4you)] == anchor2image4you:
                                       # --------------------------------------------------------------------------
                                       # HTTP TO YOURDRAGONXI.ORG
                                       # --------------------------------------------------------------------------
                                       ack2file = False
                                       ack2image4you = True
                                       message2print = "{(Step 7G/33) concluded" + "; ack2image4you-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)
                                except:
                                    message2print = "{(Step 7Z7/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False                                        
                                try: 
                                    message2print = "{(Step 7H1/33) got" + "; ack2file-got-by-generate2dragon4xi: " + str(ack2file)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # got; ack2file-got-by-generate2dragon4xi: True; time: 05:11:31 06/02/12 Pacific Daylight Time}
                                    
                                    message2print = "{(Step 7H2/33) got" + "; ack2hyperlink-got-by-generate2dragon4xi: " + str(ack2hyperlink)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # got; ack2hyperlink-got-by-generate2dragon4xi: False; time: 05:11:31 06/02/12 Pacific Daylight Time}
                                                                           
                                    if ((ack2file is True) and (ack2hyperlink is False)):
                                       # --------------------------------------------------------------------------
                                       # FILE
                                       # --------------------------------------------------------------------------
                                       message2print = "{(Step 7H3/33) concluded" + "; ack2file-concluded-by-generate2dragon4xi: " + str(target2search[0:33]) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)   
                                       # spec_std_007_3/, spec_ui_007_3/, index_bus_lambda/, index_bus_lambda/ 
                                       # ../pat/spec_aut_007_2, ../mil/spec_aut_007_1 
                                       # #001">[001]</a>~ 
                                       # ../../wiki/h/hydrogen/" target="_
                                       # ../../images/jpg/xi_bus_01/"
                                       # ../../images/png/sensor_bus_01/" ; time: 11:59:51 05/28/12 Pacific Daylight Time}
                                       # ack2file-concluded-by-generate2dragon4xi: ../pat/spec_pow_009_2/">Patrol</a; time: 01:07:36 05/29/12 Pacific Daylight Time}
                                       # ack2file-concluded-by-generate2dragon4xi: ../xi/distance_range_base4xi_xi">; time: 05:53:52 05/29/12 Pacific Daylight Time}
                                       # bp_007/#0071/">First year</a></td
                                       # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                       # bp_001/"><img src="http://www.you; time: 05:11:31 06/02/12 Pacific Daylight Time}
                                       
                                except:
                                       message2print = "{(Step 7Z8/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)
                                       # 
                                       ack2job4line = False
                                                   
                                # ----------------------------------------------------------------------------------
                                # (Step 8/33) OF GENERATE2DRAGON4XI - SOLVE ANCHOR OBJECT AND ACT!
                                # ----------------------------------------------------------------------------------                     
                                message2print = "{(Step 8/33) commented" + "; solving-anchor-start-generate2dragon4xi-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # solving-anchor-start-generate2dragon4xi ; time: 06:32:47 05/29/12 Pacific Daylight Time} with ../xi/distance_range_base4xi_xi">
                                try:
                                    if ((ack2file is True) and (ack2relative is False) and (ack2embedded is False)):
                                        # --------------------------------------------------------------------------
                                        # REFERRED OBJECT IS ANOTHER FILE IN THE SAME FOLDER 
                                        # --------------------------------------------------------------------------
                                        message2print = "{(Step 8A1/33) commented" + "; another-file-in-the-same-folder-by-generate2dragon4xi-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # another-file-in-the-same-folder-by-generate2dragon4xi-by-generate2dragon4xi ; time: 23:51:56 06/01/12 Pacific Daylight Time}
                                        
                                        if ((ack2jpg4image is True) or (ack2png4image is True)):
                                            pass
                                        else:    
                                            count2portal4anchor = count2portal4anchor + 1
                                            message2print = "{(Step 8A2/33) added" + "; count2portal4anchor-added-by-generate2dragon4xi: " + str(count2portal4anchor) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # count2portal4anchor-added-by-generate2dragon4xi: 2; time: 05:11:31 06/02/12 Pacific Daylight Time}
                                             
                                        index2end4file = str.find(target2search,end2short4object)                           
                                        if index2end4file == -1:
                                            message2print = "{(Step 8Z21/33) yielded" + "; target2search-yielded-by-generate2dragon4xi: " + str(target2search)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print) 
                                            # 
                                        else:
                                            # ----------------------------------------------------------------------
                                            # CREATE STANDARD FILE OBJECT WITH PROPER EXTENSION 
                                            # ----------------------------------------------------------------------
                                            message2print = "{(Step 8A3/33) commented" + "; building-extension-for-the-same-folder-by-generate2dragon4xi-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # building-extension-for-the-same-folder-by-generate2dragon4xi-by-generate2dragon4xi ; time: 23:51:56 06/01/12 Pacific Daylight Time}
                                            
                                            object2load = None
                                            try:
                                                if ack2jpg4image is True:
                                                    object2load = target2search[:index2end4file] + '.jpg'
                                                    message2print = "{(Step 8A4/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    #
                                                if ack2png4image is True:
                                                    object2load = target2search[:index2end4file] + '.png'
                                                    message2print = "{(Step 8A5/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    #                                                
                                                if ((ack2png4image is False) and (ack2jpg4image is False)):
                                                    index2end4embedded = str.find(target2search,'#')
                                                    if index2end4embedded == -1:
                                                        object2load = target2search[:index2end4file] + '.html'
                                                        message2print = "{(Step 8A6/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                        print4xi(class2print, method2print, message2print)
                                                        # bp_001.html
                                                    else:
                                                        # target2search-set-by-generate2dragon4xi to: bp_007/#0071/">First year</a></td>
                                                        # object2load-concluded-by-generate2dragon4xi: bp_007/#0071.html <--- *** error ***
                                                        object2load = target2search[:index2end4embedded-1] + '.html'
                                                        
                                                        message2print = "{(Step 8A7/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                        print4xi(class2print, method2print, message2print)
                                                        # bp_007.html
                                                        # 
                                                path2load = path2read4xi + object2load
                                                
                                                message2print = "{(Step 8A8/33) set" + "; path2load-set-by-generate2dragon4xi to: " + str(path2load)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # V://JOB//studio4xi//cc//generate//in//bp_001.html 
                                                    
                                            except:
                                                ack2job4line = False
                                                count2failure4absolute = count2failure4absolute + 1
                                                
                                                message2print = "{(Step 8Z1/33) failed" + "; object2load4absolute-failed-by-generate2dragon4xi: " + str(path2load) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # V://JOB//studio4xi//cc//generate//in//spec_std_007_3.html, spec_ui_007_3.html, index_bus_lambda.html                                            
                                            
                                            message2print = "{(Step 8B1/33) commented" + "; trying-to-open-file-in-the-same-folder-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            try:
                                                message2print = "{(Step 8B2/33) opening" + "; path2load-opening-by-generate2dragon4xi: " + str(path2load) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # V://JOB//studio4xi//cc//generate//in//bp_001.html
                                                
                                                file2load = None
                                                file2load = open(path2load,'r')
                                                message2print = "{(Step 8B3/33) opened" + "; file2load-opened-by-generate2dragon4xi: " + str(file2load) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//bp_001.html' mode='r' encoding='cp1252'>
                                                
                                                                                          
                                                file2load.close()                                            # 
                                                message2print = "{(Step 8B4/33) closed" + "; file2load-closed-by-generate2dragon4xi: " + str(file2load) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//bp_001.html' mode='r' encoding='cp1252'>  
                                            except:
                                                ack2job4line = False
                                                count2failure4absolute = count2failure4absolute + 1
                                                
                                                message2print = "{(Step 8Z21/33) failed" + "; open2file4absolute-failed-by-generate2dragon4xi: " + str(path2load) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # 
                                                
                                                message2print = "{(Step 8Z22/33) got" + "; input2explore-got-by-generate2dragon4xi: " + str(input2explore)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # 
                                                
                                            message2print = "{(Step 8C1/33) commented" + "; passed-steps-required-to-create-standard-file-object-with-proper-extension-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print) 
                                            # passed-steps-required-to-create-standard-file-object-with-proper-extension-by-generate2dragon4xi ; time: 05:11:31 06/02/12 Pacific Daylight Time}
                                            # JATKA 
#                                             message2print = "{(Step 8C2/33) got" + "; line2process-got-by-generate2dragon4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
#                                             print4xi(class2print, method2print, message2print)
#                                             message2print = "{(Step 8C3/33) got" + "; target2search-got-by-generate2dragon4xi: " + str(target2search)  + "; time: " + time4xi() + "}"
#                                             print4xi(class2print, method2print, message2print)
                                            
                                               
                                except:
                                       message2print = "{(Step 8Z1/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                       print4xi(class2print, method2print, message2print)
                                       # 
                                       ack2job4line = False       
                                try:
                                    message2print = "{(Step 9A/33) commented" + "; starting-to-check-case-referred-object-is-another-file-and-is-located-in-other-folder " + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>              
                                    
                                    message2print = "{(Step 9B/33) got" + "; line2process-got-by-generate2dragon4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    
                                    message2print = "{(Step 9C/33) got" + "; target2search-got-by-generate2dragon4xi: " + str(target2search)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    
                                    if ((ack2file is True) and (ack2relative is True) and (ack2embedded is False)):
                                        # ------------------------------------------------------------------------------------
                                        # REFERRED OBJECT IS ANOTHER FILE AND IS LOCATED IN OTHER FOLDER
                                        # ------------------------------------------------------------------------------------
                                        # ../pat/spec_aut_007_2.html, ../../wiki/h/hydrogen/   
                                        if ((ack2jpg4image is True) or (ack2png4image is True)):
                                            pass
                                        else:    
                                            count2portal4anchor = count2portal4anchor + 1
                                        
                                        
                                        index2end4file = str.find(target2search,end2short4object)                        
                                        if index2end4file == -1:
                                            index2end4file = str.find(target2search,end2mini4object)                        
                                            if index2end4file == -1:
                                                message2print = "{(Step 9Y1/33) yielded" + "; target2search-yielded-by-generate2dragon4xi: " + str(target2search)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                #
                                            else:
                                                message2print = "{(Step 9A2/33) got" + "; mini-anchor-got-by-generate2dragon4xi: " + str(target2search)  + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # <a href="../xi/distance_range_base4xi_xi">Distance Range Base4Xi - Xi</a>   
                                                # ../../../spec/zeta/mil/spec_mon_009_1/#001
                                        else:
                                            message2print = "{(Step 9A1/33) got" + "; index2end4file-got-by-generate2dragon4xi: " + str(index2end4file)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #         
                                                
                                        #
                                            
                                        
#---------------------------------------# ../../images/png/sensor_bus_01/"
                                        index2jpg = str.find(target2search,'jpg')                                       # jpg image ?
                                        if index2jpg == -1:
                                            # ----------------------------------------------------------------------
                                            # NOT JPG
                                            # ----------------------------------------------------------------------    
                                            index2png = str.find(target2search,'png')                                   # png image ?
                                            if index2png == -1:
                                                # ----------------------------------------------------------------------
                                                # NO JPG AND NO PNG IMAGE
                                                # ----------------------------------------------------------------------                                        
                                                message2print = "{(Step 9Y2/33) yielded" + "; target2search-yielded-by-generate2dragon4xi: " + str(target2search) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # 
                                                
                                                ack2html4type = True             
                                            else:
                                                # ----------------------------------------------------------------------
                                                # PNG IMAGE FOUND BUT CHECK THAT HTML OBJECT NOT ALREADY FOUND
                                                # ----------------------------------------------------------------------
                                                if index2end4file == -1:                                            
                                                    ack2image4type = True
                                                    ack2png4image = True
                                                    count2png4image = count2png4image + 1
                                                    count2total4image = count2total4image + 1
                                                    message2print = "{(Step 9B/33) added" + "; count2png4image-added-by-generate2dragon4xi: " + str(count2png4image) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    # 
                                                    ack2reference4check = True
                                                else:
                                                    pass    
                                        else:
                                            # ----------------------------------------------------------------------
                                            # JPG IMAGE FOUND BUT CHECK THAT HTML OBJECT NOT ALREADY FOUND
                                            # ----------------------------------------------------------------------
                                            # ../../../spec/legal/legal_notice/"><img src="https://www.yourdragonxi.org/web/images/jpg/legal.jpg" height="120" width="204" align="left" /></a></td>
                                            #  
                                            if index2end4file == -1:
                                                ack2image4type = True
                                                ack2jpg4image = True
                                                count2jpg4image = count2jpg4image + 1
                                                count2total4image = count2total4image + 1
                                                message2print = "{(Step 9C/33) added" + "; count2jpg4image-added-by-generate2dragon4xi: " + str(count2jpg4image) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print)
                                                # 
                                            
                                                ack2reference4check = True
                                            else:
                                                pass
                                                    
                                        if ack2jpg4image is True:
                                            object2load = target2search[:index2end4file] + '.jpg'
                                        else:
                                            if ack2png4image is True:
                                                object2load = target2search[:index2end4file] + '.png'
                                            else:
                                                # ------------------------------------------------------------------
                                                #
                                                # ------------------------------------------------------------------
                                                index2end4embedded = str.find(target2search,'#')
                                                if index2end4embedded == -1:
                                                    object2load = target2search[:index2end4file] + '.html'
                                                    message2print = "{(Step 9D/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    # spec_std_007_3.html, spec_ui_007_3.html, index_bus_lambda.html, ../../../spec/legal/legal_notice.html
                                                else:
                                                    #
                                                    object2load = target2search[:index2end4embedded-1] + '.html'
                                                        
                                                    message2print = "{(Step 9F/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                    #         
                                                
                                                
                                        message2print = "{(Step 9G/33) concluded" + "; object2load-concluded-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # ../../wiki/h/hydrogen.html
                                        # level2input = 1
                                        # branch2input = 10
                                        # leaf2branch = 6
                                        # branch2leaf = 1     
                                        # path2input4portal = kb4site[level2input] [branch2input] [leaf2branch] [branch2leaf]
                                        #                   = ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//bus// 
                                        #                   = ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//
                                        #                   = ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//wiki//h//hydrogen.html
                                        # ../../images/jpg/xi_bus_01/" 
                                        # object2load-concluded-by-generate2dragon4xi: ../pat/spec_pow_009_2.html; time: 01:07:36 05/29/12 Pacific Daylight Time}
                                        up2level0 = '../../../'
                                        index2level0 = str.find(object2load,up2level0)
                                        if index2level0 == -1:
                                            up2level1 = '../../'
                                            index2level1 = str.find(object2load,up2level1)
                                            if index2level1 == -1:
                                                up2level2 = '../'
                                                index2level2 = str.find(object2load,up2level2)
                                                if index2level2 == -1:
                                                    message2print = "{(Step 9Z0/33) failed" + "; index2level2-failed-by-generate2dragon4xi: " + str(object2load) + "; time: " + time4xi() + "}"
                                                    print4xi(class2print, method2print, message2print)
                                                else:
                                                    #  ADJUST FOR EACH FOLDER TO BE CHECKED WITH THIS PROGRAM
                                                    # [ACK] kb4site [1] [10] [1] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//alpha//'
                                                    # [ACK] kb4site [1] [10] [2] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//' 
                                                    # [ACK] kb4site [1] [10] [3] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//delta//'
                                                    # [ACK] kb4site [1] [10] [4] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//epsilon//'
                                                    # [ACK] kb4site [1] [10] [5] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//gamma//'
                                                    # [ACK] kb4site [1] [10] [6] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//lambda//'
                                                    # [ACK] kb4site [1] [10] [7] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//zeta//'
                                                    # [ACK] kb4site[1] [10] [8] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//formula//'                                                       
                                                    # - [ACK] base4xi
                                                    # - [ACK] bio
                                                    # - [ACK] calc
                                                    # - [ACK] ecar
                                                    # - [ACK] helicopter
                                                    # - [ACK] hrw
                                                    # - [ACK] matter
                                                    # - [ACK] pod4xi 
                                                    # - [ACK] sensor4xi
                                                    # - [ACK] srw
                                                    # - [ACK] xcopter
                                                    # - [ACK] xi
                                                    # [NACK] [1] [12] [1] [3] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//ss//'
                                                    # [NACK] [1] [12] [1] [1] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//vc//bp//' <-- FOCUS 
                                                    
                                                    # =============   ADJUST HERE =====================================
                                                    path2load = kb4site [1] [12] [1] [1] + object2load[len(up2level2):]   
                                                    # =================================================================  
                                            else:
                                                # [ACK] kb4site[1] [10] [0] = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//'
                                                path2load = kb4site[1] [10] [0] + object2load[len(up2level1):]   
                                                   
                                        else:
                                            # [ACK] kb4site[0] [0]  = ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//'
                                            path2load = kb4site[0] [0] + object2load[len(up2level0):]
                                            

                                       
                                        message2print = "{(Step 9C2/33) concluded" + "; path2load-concluded-by-generate2dragon4xi: " + str(path2load) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # V://JOB//studio4xi//cc//generate//pat//spec_aut_007_2.html
                                        # ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//wiki/h/hydrogen.html
                                        # ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//wiki/f/fuel_cell.html
                                        # ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//images/jpg/xi_bus_01.jpg                   
                                        # ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//beta//alpha/bus/index_bus_alpha.html *** error ***
                                        
                                        try:
                                            file2load = open(path2load,'r')
                                            message2print = "{(Step 9D2/33) opened" + "; file2load-opened-by-generate2dragon4xi: " + str(file2load) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//pat//spec_aut_007_2.html' mode='r' encoding='cp1252'>
                                            # <_io.TextIOWrapper name=ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//wiki/h/hydrogen.html' mode='r' encoding='cp1252'>
                                            # <_io.TextIOWrapper name=ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//images/jpg/xi_bus_01.jpg' mode='r' encoding='cp1252'>
                                            
                                            file2load.close()                                            # 
                                            message2print = "{(Step 9E2/33) closed" + "; file2load-closed-by-generate2dragon4xi: " + str(file2load) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//pat//spec_aut_007_2.html' mode='r' encoding='cp1252'>
                                            # <_io.TextIOWrapper name=ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//wiki/h/hydrogen.html' mode='r' encoding='cp1252'> 
                                            #
                                            # <_io.TextIOWrapper name=ROOT4XI + '//DRAGONXI//PC4Xi//ComDragonxi//WebSite//spec//images/jpg/xi_bus_01.jpg' mode='r' encoding='cp1252'> 
                                        except:
                                            count2failure4relative = count2failure4relative + 1
                                        
                                            message2print = "{(Step 9Z21/33) failed" + "; open2file-failed-by-generate2dragon4xi: " + str(path2load) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # V://JOB//studio4xi//cc//generate//in//index_bus_lambda.html
                                            
                                            message2print = "{(Step 9Z22/33) got" + "; input2explore-got-by-generate2dragon4xi: " + str(input2explore)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # 
                                            
                                            ack2job4line = False
                                                
                                             
                                        message2print = "{(Step 9V/33) commented" + "; passed-steps-object-is-another-file-and-is-located-in-other-folder-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)                      
                                except:
                                        message2print = "{(Step 9Z1/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                        # 
                                        ack2job4line = False          
                                
                                message2print = "{(Step 10/33) commented" + "; starting-to-check-case-referred-object-is-embedded-in-this-file-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                try:
                                    if ((ack2file is True) and (ack2embedded is True)):
                                        # ------------------------------------------------------------------------------------
                                        # REFERRED OBJECT IS EMBEDDED IN THIS FILE
                                        # ------------------------------------------------------------------------------------
                                        count2embedded4anchor = count2embedded4anchor + 1
                                        message2print = "{(Step 10A/33) commented" + "; referred-object-is-embedded-in-this-file-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print)
                                except:
                                    message2print = "{(Step 10Z1/33) failed" + "; type-decicion-failed-by-generate2dragon4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                    ack2job4line = False 
                                
                                message2print = "{(Step 11A/33) commented" + "; one-task-of-the-job-done-in-this-line-by-generate2dragon4xi " + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # one-task-of-the-job-done-in-this-line-by-generate2dragon4xi ; time: 05:11:31 06/02/12 Pacific Daylight Time}                           
                            else:
                                # -------------------------------------------------------------------------------------------
                                # NO JOB IN THIS LINE
                                # -------------------------------------------------------------------------------------------    
                                ack2job4line = False    
                                
                        # ---------------------------------------------------------------------------------------------------
                        # END OF JOB TRY
                        # ---------------------------------------------------------------------------------------------------         
                            
                            
                        except:
                            # -----------------------------------------------------------------------------------------------
                            # JOB FOR LINE FAILED!
                            # -----------------------------------------------------------------------------------------------
                            message2print = "{(Step 13Z1/33) failed" + "; target2search-failed-by-generate2dragon4xi: " + str(target2search) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <br /><img src="../../images/jpg/xi_bus_01/" height="150" width="200" align="middle" />
                            
                            ack2job4line = False
                        
                        
                    # ------------------------------------------------------------------------------------
                    # EOF PROCESS OF ONE LINE OF SOURCE FILE OF VIRTUAL DEVICE 
                    # ------------------------------------------------------------------------------------                          
                    
                                                
                    # ------------------------------------------------------------------------------------
                    # GET READY TO PREPARE LINE FOR WRITING
                    # ------------------------------------------------------------------------------------    
                    line2write = line2process
                        
                    message2print = "{(Step 7A/33) set" + "; line2write-set-by-generate2dragon4xi to: " + str(line2write)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <p>       
                    # 
    
                                                               
                    # ---------------------------------------------------------------------------------
                    # (Step 29/33) OF GENERATE2DRAGON4XI - WRITE LINE
                    # ---------------------------------------------------------------------------------
                    file2output.write(line2write)
                    message2print = "{(Step 7V/33) wrote" + "; line2write-wrote-by-generate2dragon4xi: " + str(line2write) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)              
                    # <p>
                    # ...
                    # </p>
                    if ((ack2anchor4line is False) and (ack2image4line is False)) or (ack2yoimage is True):
                        count2skipped = count2skipped + 1
                        message2print = "{(Step 29A/33) added" + "; count2skipped-added-by-generate2dragon4xi: " + str(count2skipped) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                                                    
                    # ---------------------------------------------------------------------------------
                    # EOF LINE
                    # ---------------------------------------------------------------------------------         
                    
            # ---------------------------------------------------------------------------------
            # EOF FILE
            # ---------------------------------------------------------------------------------
            message2print = "{(Step 30B/33) performed" + "; file2input-performed-by-generate2dragon4xi: " + str(file2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html' mode='r' encoding='cp1252'>
            
            ack2close = True
            try:       
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF GENERATE2DRAGON4XI - CLOSE OUTPUT FILE
                # -----------------------------------------------------------------------------------------
                file2output.close()                                            # 
                          
                message2print = "{(Step 31A/33) closed" + "; file2output-closed-by-generate2dragon4xi: " + str(file2output) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)   
                # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html' mode='r' encoding='cp1252'>          
            except:
                ack2close = False
                message2print = "{(Step 31Z1/33) failed" + "; ack2close-failed-by-generate2dragon4xi: " + str(ack2close) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # False
        
            

        else:
            message2print = "{(Step 1Z/33) yielded" + "; ack2output-yielded-by-generate2dragon4xi: " + str(ack2output)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)

        if ack2input is True:
            ack2close = True
            try:                                                                           
                # ---------------------------------------------------------------------------------
                # (Step 32/33) OF GENERATE2DRAGON4XI - CLOSE INPUT FILE
                # ---------------------------------------------------------------------------------                
                file2input.close()
                message2print = "{(Step 32A/33) closed" + "; file2input-closed-by-generate2dragon4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_aut_007_3.html' mode='r' encoding='cp1252'>
                # <_io.TextIOWrapper name='V://JOB//studio4xi//cc//generate//in//spec_dat_007_3.html' mode='r' encoding='cp1252'>
            except:
                ack2close = False
                message2print = "{(Step 32Z2/33) failed" + "; ack2close-failed-by-generate2dragon4xi: " + str(ack2close) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                                                  
    else:
        message2print = "{(Step 1Z/33) skipped" + "; input2explore-skipped-by-generate2dragon4xi: " + str(input2explore)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        
    # ---------------------------------------------------------------------------------------------
    # EOF FUNCTION
    # ---------------------------------------------------------------------------------------------                                   
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global count2skipped
    global count2failure4absolute
    global count2failure4relative
    global count2found4line
    global count2modify4anchor
    global count2total4anchor
    global count2total4image
    global count2total
    global count2embedded4anchor
    global count2web4anchor
    global count2portal4anchor    
    global count2jpg4image
    global count2png4image
    global count2your4image    
    
    global kb4site
    global kb2url4check    
    
    global level2input
    global branch2input
    global leaf2branch
    global branch2leaf   
     
    global path2input4portal                     
    global path2read4xi
    global path2write4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # (Step 1/33) OF MAIN GENERATE2DRAGON4XI - INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1A/33) OF MAIN GENERATE2DRAGON4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
    try: 

        set2trace4generate()                                                                                        # trace all classes and functions in the system
        deny2trace4generate()                                                                                       # deny trace for all classes and functions in the system
        tailor2trace4generate()                                                                                     # tailor trace for this test    
    
        # --------------------------------------------------------------------------------------------- 
        # (Step 2/33) OF MAIN GENERATE2DRAGON4XI - START
        # ---------------------------------------------------------------------------------------------
        print("(Step 2A/33) OF MAIN GENERATE2DRAGON4XI - STARTED ", time4xi()) 
        #       
        print("(Step 2B/33) OF MAIN GENERATE2DRAGON4XI - PATH2READ4XI: ", path2read4xi)
        # V://JOB//studio4xi//cc//generate//in//  
        print("(Step 2C/33) OF MAIN GENERATE2DRAGON4XI - PATH2WRITE4XI: ", path2write4xi)
        # V://JOB//studio4xi//cc//generate//out//
  
        print("(Step 2D/33) OF MAIN GENERATE2DRAGON4XI - ROOT2PORTAL: ", kb4site[0] [0])
        # ROOT4XI//DRAGONXI//PC4Xi//ComDragonxi//WebSite//
                
        print("(Step 2E/33) OF MAIN GENERATE2DRAGON4XI - LEVEL2INPUT: ", level2input)
        # 1 
        print("(Step 2F/33) OF MAIN GENERATE2DRAGON4XI - BRANCH2INPUT: ", branch2input)
        # 10
        print("(Step 2G/33) OF MAIN GENERATE2DRAGON4XI - LEAF2BRANCH: ", leaf2branch)
        # 6
        print("(Step 2H/33) OF MAIN GENERATE2DRAGON4XI - BRANCH2LEAF: ", branch2leaf)
        # 1     
        print("(Step 2I/33) OF MAIN GENERATE2DRAGON4XI - PATH2INPUT4PORTAL: ", path2input4portal)
        #    
        
         
        # --------------------------------------------------------------------------------------------- 
        # (Step 3/33) OF MAIN GENERATE2DRAGON4XI - WALK
        # ---------------------------------------------------------------------------------------------   
        for file2walk in DirectoryWalker(path2read4xi):
            # ----------------------------------------------------------------------------------------- 
            #
            # -----------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                print ("(Step 3A/33) OF MAIN GENERATE2DRAGON4XI - DIRECTORY: ", file2walk)
                # 
            if os.path.isfile(file2walk):
                print("(Step 3B/33) OF MAIN GENERATE2DRAGON4XI - INPUT FILE: ", file2walk)
                
                count2skipped = 0                                                                                   # initialize counters for the new file to be explored
                count2failure4absolute = 0
                count2failure4relative = 0
                count2found4line = 0
                count2modify4anchor = 0
                count2total4anchor = 0
                count2total4image = 0
                count2total = 0
                count2embedded4anchor = 0
                count2web4anchor = 0
                count2portal4anchor = 0
                count2jpg4image = 0
                count2png4image = 0
                count2your4image = 0                  
                
                kb2url4check = {}                                                                                   # initialize knowledgebase for external URLs referred for the new file to be explored
                
                generate2dragon4xi(file2walk)

                # -------------------------------------------------------------------------------------
                # (Step 4/33) OF MAIN GENERATE2DRAGON4XI - STATISTICS 
                # ------------------------------------------------------------------------------------- 
                print('=' *33)
                print ('STATISTICS OF FILE (file2walk): ', file2walk) 
                print ('ANCHORED LINES (count2found4line): ', count2found4line)
                print ('ANCHORS (count2total4anchor): ', count2total4anchor)
                print ('- EMBEDDED ANCHORS (count2embedded4anchor): ', count2embedded4anchor)
                print ('- PORTAL ANCHORS (count2portal4anchor): ', count2portal4anchor)
                print ('- WEB ANCHORS (count2web4anchor): ', count2web4anchor)
                if count2web4anchor > 0:
                    keys2check = kb2url4check.keys()
                    for key2check in keys2check:
                        print ('~~ ANCHOR TO CHECK ', kb2url4check[key2check])
                print ('- MODIFIED ANCHORS (count2modify4anchor): ', count2modify4anchor)
                
                print ('IMAGES (count2total4image): ', count2total4image)
                print ('- JPG (count2jpg4image): ', count2jpg4image)
                print ('- PNG (count2png4image): ', count2png4image)
                print ('- YOUR (count2your4image): ', count2your4image)
                test2total = count2jpg4image + count2png4image # not counted to sum: count2your4image 
                if test2total == count2total4image:
                    pass
                else:
                    print ('(Step 4Z1/33) OF MAIN GENERATE2DRAGON4XI *** FAILED: RE-CALCULATED IMAGE TOTAL (test2total) ', test2total, " .NE. IMAGE TOTAL (count2total4image): ", count2total4image, " ***")
                
                if count2failure4absolute > 0:
                    print ('- *** FAILED TO OPEN IN THE SAME FOLDER (count2failure4absolute): ', count2failure4absolute, ' ***')
                if count2failure4relative > 0:    
                    print ('- *** FAILED TO OPEN IN RELATIVE FOLDER (count2failure4relative): ', count2failure4relative, ' ***')
                  
                print ('SKIPPED LINES: ', count2skipped)
                print ('FOUND LINES: ', count2found4line)
      
                test2total = count2found4line + count2skipped
                if test2total == count2total:
                    pass
                else:
                    print ('(Step 4Z2/33) OF MAIN GENERATE2DRAGON4XI *** FAILED: RE-CALCULATED LINE TOTAL (test2total): ', test2total, " = ", count2found4line, " COUNT2FOUND4LINE(count2found4line) + ", count2skipped, " COUNT2SKIPPED(count2skipped) .NE. ORIGINAL LINE TOTAL(count2total): ", count2total, " ***")
                    
                    print ('count2total ', count2total, '(input lines read)')
                    # 215
                    print ('test2total ' , test2total, ' (= count2found4line + count2skipped')
                    # 207
                    print ('count2found4line ' , count2found4line)
                    #  90
                    print ('count2skipped ' , count2skipped)
                    # 125
                    print ('count2jpg4image ' , count2jpg4image) 
                    #  16
                    print ('count2png4image ' , count2png4image) 
                    #   3
                    print ('count2your4image ' , count2your4image)  
                    #   8
                    # ====
                    
                    # JATKA
                    
                test2total = count2embedded4anchor + count2portal4anchor + count2web4anchor - count2your4image
                if test2total == count2total4anchor:
                    pass
                else:
                    print ('(Step 4Z3A/33) OF MAIN GENERATE2DRAGON4XI *** FAILED: count2embedded4anchor + count2portal4anchor + count2web4anchor: ', test2total, " .NE. count2total4anchor: ", count2total4anchor, " ***")
                    print ('count2total4anchor ' , count2total4anchor)
                    # 92
                    print ('test2total ' , test2total)  
                    # 100
                    print ('count2embedded4anchor ', count2embedded4anchor)
                    # 0
                    print ('count2portal4anchor ', count2portal4anchor)  
                    # 96
                    print ('count2web4anchor ', count2web4anchor)    
                    # 4
                print('=' *33)
                    
        # -------------------------------------------------------------------------------------------
        # (Step 5/33) OF MAIN GENERATE2DRAGON4XI - FINISH
        # -------------------------------------------------------------------------------------------
        print("(Step 5A/33) OF MAIN GENERATE2DRAGON4XI - FINISHED ", time4xi())
        print("REMEMBER TO RETURN UPDATED MODULES TO E:\DRAGONXI\PC4Xi\ComDragonxi\WebSite")

    except:
        print("(Step 1Z1/33) OF MAIN GENERATE2DRAGON4XI *** FAILED *** ", time4xi())          
    
    finally: 
        # ---------------------------------------------------------------------------------------------    
        # ALWAYS PRINT TRACE
        # ---------------------------------------------------------------------------------------------     
        print2trace4dragonize(t2xi)        
      
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# L:\temp\txt\generate2dragon4xi.txt
# E:\Studio4Xi\web\xml\ace-dragonize2scope.xml
# E:\Studio4Xi\web\xml\reason-dragonize2scope.xml
# E:\Studio4Xi\web\xml\sense-dragonize2scope.xml
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of generate2dragon4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

